# Apache Solr for TYPO3 CMS

[![Build Status](https://travis-ci.com/TYPO3-Solr/ext-solr.svg?branch=master)](https://travis-ci.com/TYPO3-Solr/ext-solr)
[![Scrutinizer Code Quality](https://scrutinizer-ci.com/g/TYPO3-Solr/ext-solr/badges/quality-score.png?b=master)](https://scrutinizer-ci.com/g/TYPO3-Solr/ext-solr/?branch=master)
[![Code Coverage](https://scrutinizer-ci.com/g/TYPO3-Solr/ext-solr/badges/coverage.png?b=master)](https://scrutinizer-ci.com/g/TYPO3-Solr/ext-solr/?branch=master)
[![Latest Stable Version](https://poser.pugx.org/apache-solr-for-typo3/solr/v/stable)](https://packagist.org/packages/apache-solr-for-typo3/solr)
[![Latest Unstable Version](https://poser.pugx.org/apache-solr-for-typo3/solr/v/unstable)](https://packagist.org/packages/apache-solr-for-typo3/solr)
[![License](https://poser.pugx.org/apache-solr-for-typo3/solr/license)](https://packagist.org/packages/apache-solr-for-typo3/solr)
[![Monthly Downloads](https://poser.pugx.org/apache-solr-for-typo3/solr/d/monthly)](https://packagist.org/packages/apache-solr-for-typo3/solr)

A TYPO3 extension that integrates the Apache Solr enterprise search server with TYPO3 CMS.

The extension has initially been developed by dkd Internet Service GmbH and is now being continued as a community project. The version you find here is a version that does not contain all the features that have been implemented yet. These features can be obtained through add-ons for the extension.

In case you need access to the full feature set, please feel free to contact us for details.

Things we are working on or got working already include the following:

- Statistics
- An Indexing Queue to be independent from frontend rendering and adding content to Solr as soon as an editor creates a content element in the backend
- Suggest / Autocomplete
- More Like This
- Several Reports
- Advanced faceting features including hierarchical facets
- Backend Module for Solr administration
- Results Grouping
- Language Detection
- Crawling of External non-TYPO3 Websites
- more ...

We're open for [contributions](./CONTRIBUTING.md) !

Please find further information regarding Apache Solr and its related projects at the following links:

- http://www.typo3-solr.com/
- https://www.dkd.de/de/leistungen/enterprise-websites/enterprise-search/
- https://github.com/TYPO3-Solr
- http://lucene.apache.org/
- http://lucene.apache.org/solr/
- http://tomcat.apache.org
- http://www.eclipse.org/jetty/

To try out Apache Solr for TYPO3 visit [www.typo3-solr.com](http://www.typo3-solr.com) where we've set up a basic configuration.

![dkd Internet Service GmbH](./Resources/Public/Images/dkd_logo.png)

## Documentation and Support

-   **Main Documentation:**

   https://docs.typo3.org/p/apache-solr-for-typo3/solr/master/en-us/Index.html


-   **Slack Channel:**

    https://typo3.slack.com/messages/ext-solr/

    (request your invite for Slack here: https://forger.typo3.org/slack)


-   **Mailinglist:**

    http://lists.typo3.org/cgi-bin/mailman/listinfo/typo3-project-solr

## <a name="Contributions"></a>Contributions

[You want to contribute and like to know how? Check our guidelines about how to contribute to EXT:meilisearch](./CONTRIBUTING.md)
